﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SteccaScript : MonoBehaviour {

	public ParticleScript pa, pb;
	public float steccaLen = 0.0f;

	// Use this for initialization
	void Start () {
		steccaLen = Vector3.Distance (pa.transform.position, pb.transform.position);
	}
		
	// update per il rendering
	void Update () {
		
		float distAB = Vector3.Distance (pa.transform.position, pb.transform.position);

		transform.position = (pa.transform.position + pb.transform.position) / 2;
		transform.localScale = new Vector3 (0.25f, distAB / 2, 0.25f);

		Vector3 aMenoB = pa.transform.position - pb.transform.position;
		transform.localRotation = Quaternion.FromToRotation (Vector3.up, aMenoB);
	}

	void enforceConstraint(){
		Vector3 d = pa.transform.position - pb.transform.position;
		float delta = (d.magnitude - steccaLen);
		Vector3 dir = d.normalized;
		// ipotesi: stessa massa
		pa.transform.position -= dir * (delta / 2);
		pb.transform.position += dir * (delta / 2);
	}

	//
	void FixedUpdate(){
		enforceConstraint ();
	}
}
